require 'rack'

class TrailsServer
  def initialize(port, host)
    @port = port
    @host = host
    router = Router.new
    router.draw(&ROUTES)

    trails_app = Proc.new do |env|
      req = Rack::Request.new(env)
      res = Rack::Response.new
      router.run(req, res)
      res.finish
    end

    @app = Rack::Builder.new do
      use StaticAssetsServer
      use Rack::MethodOverride
      run trails_app
    end
  end

  def start
    Rack::Server.start(
      app: @app,
      Port: @port,
      Host: @host
    )
  end
end
