module DynamicArchive
  module Searchable
    def where(*args)
      if args[0].is_a?(Hash)
        # without 'LIKE', query cannot find ids correctly
        where_line = args[0].map { |key, v| "#{key} LIKE ?"}.join(" AND ")
        results = DBConnection.execute(<<-SQL, args[0].values)
          SELECT
            *
          FROM
            #{self.table_name}
          WHERE
            #{where_line}
        SQL
      else
        results = sql_query_where(args)
      end

      self.parse_all(results)
    end

    def sql_query_where(args)
      where_line = args[0]
      DBConnection.execute(<<-SQL, args[1..-1])
        SELECT
          *
        FROM
          #{self.table_name}
        WHERE
          #{where_line}
      SQL
    end

    def find_by(params)
      results = where(params)
      results.first
    end
  end
end
