class StaticAssetsServer
  attr_reader :app, :res, :req

  def initialize(app)
    @app = app
    @res = Rack::Response.new
  end

  def call(env)
    @req = Rack::Request.new(env)
    if req.path =~ /^\/public\/assets/
      serve_asset
    else
      app.call(env)
    end
  end

  private
    def serve_asset
      asset = File.read(File.join(PROJECT_ROOT, req.path))

      file_type = req.path.match(/\..+$/)[0]
      res["Content-Type"] = Rack::Mime::MIME_TYPES[file_type]

      res.write(asset)
      res.finish
    end
end
