class Flash
  attr_reader :now, :later

  def initialize(req)
    messages = req.cookies["_trails_flash"]
    @now = JSON.parse(messages) if messages
    @now ||= {}
    @later = {}
  end

  def [](message_type)
    now[message_type]
  end

  def []=(message_type, value)
    later[message_type] = value
  end

  def store_flash(res)
    self[:path] = "/"
    self[:value] = later.to_json
    res.set_cookie("_trails_flash", later)
  end
end
