require 'json'

class Session
  def initialize(req)
    cookie = req.cookies["_trails_app"]
    if cookie
      @data = JSON.parse(cookie)
    else
      @data = {}
    end
  end

  def [](key)
    @data[key]
  end

  def []=(key, val)
    @data[key] = val
  end

  def store_session(res)
    cookie = {
      path: "/",
      value: @data.to_json
    }
    res.set_cookie("_trails_app", cookie)
  end
end
