require 'fileutils'
require 'pathname'
require_relative "version"

module Trails
  def self.project_root
    current_dir = Pathname.new(Dir.pwd)
    current_dir.ascend do |dir|
      gemfile = File.exist?(File.join(dir, 'Gemfile'))
      app_dir = Dir.exist?(File.join(dir, 'app'))
      return dir if gemfile && app_dir
    end

    nil
  end
end

TRAILS_ROOT = /^(.+)\/lib/.match(File.dirname(__FILE__))[1]
TEMPLATE_PATH = File.join(TRAILS_ROOT, 'template')
PROJECT_ROOT = Trails.project_root

require_relative "#{PROJECT_ROOT}/config/database" if PROJECT_ROOT
require_relative 'controller_base'
require_relative 'router'
require_relative 'asset_server'
require_relative 'exception_handler'
require_relative "../dynamic-archive/lib/base"


require_relative "cli"
